'use strict';
var Generator = require('yeoman-generator');
var chalk = require('chalk');
var yosay = require('yosay');

module.exports = Generator.extend({
  prompting: function () {
    // Have Yeoman greet the user.
    this.log(yosay(
      'cpf create'
    ));
  },

  writing: {
    commonFile() {
      this.fs.copy(
        this.templatePath('cpf/build'),
        this.destinationPath('build')
      );
      this.fs.copy(
        this.templatePath('cpf/config'),
        this.destinationPath('config')
      );
      this.fs.copy(
        this.templatePath('cpf/src'),
        this.destinationPath('src')
      );
      this.fs.copy(
        this.templatePath('cpf/test'),
        this.destinationPath('test')
      );
      this.fs.copy(
        this.templatePath('cpf/index.html'),
        this.destinationPath('index.html')
      );
      this.fs.copy(
        this.templatePath('cpf/manifest.json'),
        this.destinationPath('manifest.json')
      );
      this.fs.copy(
        this.templatePath('cpf/npm'),
        this.destinationPath('npm')
      );
      this.fs.copy(
        this.templatePath('cpf/package.json'),
        this.destinationPath('package.json')
      );
      this.fs.copy(
        this.templatePath('cpf/npmrc'),
        this.destinationPath('.npmrc')
      );
      this.fs.copy(
        this.templatePath('cpf/README.md'),
        this.destinationPath('README.md')
      );
    },
    git() {
      this.fs.copy(
        this.templatePath('cpf/gitignore'),
        this.destinationPath('.gitignore')
      );
      this.fs.copy(
        this.templatePath('cpf/gitattributes'),
        this.destinationPath('.gitattributes')
      );
    },
    project() {
      this.fs.copy(
        this.templatePath('cpf/project'),
        this.destinationPath('.project')
      );
    },
    eslint() {
      this.fs.copy(
        this.templatePath('cpf/eslintrc.js'),
        this.destinationPath('.eslintrc.js')
      );
      this.fs.copy(
        this.templatePath('cpf/eslintignore'),
        this.destinationPath('.eslintignore')
      );
      this.fs.copy(
        this.templatePath('cpf/test/unit/eslintrc'),
        this.destinationPath('test/unit/.eslintrc')
      );
    },
    editorconfig() {
      this.fs.copy(
        this.templatePath('cpf/editorconfig'),
        this.destinationPath('.editorconfig')
      );
    },
    babel() {
      this.fs.copy(
        this.templatePath('cpf/babelrc'),
        this.destinationPath('.babelrc')
      );
    },
    keep() {
      this.fs.copy(
        this.templatePath('cpf/static/gitkeep'),
        this.destinationPath('static/.gitkeep')
      );
    }

  },

  install: function () {
    this.installDependencies();
  }
});
