const callHook = function (vm, hook) {
  const handlers = vm.$options[hook]
  if (handlers) {
    for (let i = 0, j = handlers.length; i < j; i++) {
      handlers[i].call(vm)
    }
  }
  vm.$emit('hook:' + hook)
}

var globalMixin = {
  methods: {
    setPageTitle: function () {
      if (this.pageTitle) {
        document.title = this.pageTitle
      }
    },
    back: function () {
      if (this.$router) {
        this.$router.go(-1)
      } else {
        window.history.back()
      }
    }
  },
  watch: {
    pageTitle: function () {
      this.setPageTitle()
    }
  },
  created: function () {
    this.setPageTitle()
  },
  activated: function () {
    for (let i = 0, j = this.$children.length; i < j; i++) {
      callHook(this.$children[i], 'activated')
    }
    this.setPageTitle()
  },
  deactivated: function () {
    for (let i = 0, j = this.$children.length; i < j; i++) {
      callHook(this.$children[i], 'deactivated')
    }
  }
}

module.exports = globalMixin
